export declare class NoteMap<T extends any> {
    static create<T extends any>(): NoteMap<T>;
    private readonly _reverseMap;
    private readonly _supportMap;
    private readonly _instanceMap;
    private constructor();
    get length(): number;
    get size(): number;
    getAllKeys(): string[];
    getAllIdentifiers(): string[];
    getAllInstances(): T[];
    keyExists(key: string): boolean;
    identifierExists(identifier: string): boolean;
    countKey(key: string): number;
    setWithIdentifier(key: string, identifier: string, value: T): this;
    setAndGetIdentifer(key: string, value: T): string;
    getKeyByIdentifier(identifier: string): string | undefined;
    getInstanceByIdentifier(identifier: string): T | undefined;
    getAllIdentifiersByKey(key: string): string[];
    getAllInstancesByKey(key: string): T[];
    removeByIdentifier(identifier: string): boolean;
    removeByValue(value: T): number;
    removeAllByKey(key: string): {
        readonly succeed: number;
        readonly failed: number;
    };
    private _getKey;
    private _getIdentifiers;
    private _addSupport;
    private _removeIdentifier;
    private _getInstance;
    private _getInstances;
    private _addInstance;
    private _removeInstance;
}
